<template>
  <div class="skills">
      <div v-if="loaded">
          <h2>My Skills</h2>
      <ul class="collection">
          <li v-for = "skill in mySkills" v-bind:key="skill.id">
              <span>{{skill.name}}</span><span>{{skill.type}}</span>
              <div>
                <router-link v-bind:to ="{name: 'editskill' , params : {skill_id: skill.skill_id}}"> <span class="edit"><font-awesome-icon icon="edit" class="edit-icon"/></span></router-link>
              <span class="delete"><font-awesome-icon icon="minus-circle" v-on:click = "onDelete(skill.skill_id)"/></span>
              </div>
          </li>
      </ul>
      <div class="newButton">
          <router-link to="/newskill"><font-awesome-icon icon="plus-circle" class="plus-circle" /></router-link>
      </div>
      </div>
      <div v-else>
          <h2>Loading...</h2>
      </div>
  </div>
</template>

<script>
import db from '@/db'
export default {
  name: 'skills',

    data () {
      return {
          mySkills : [],
          loaded : false
      }

     },

    created() {
       this.getSkills()
    },

    methods : {

      getSkills () {
          db.collection('myskills').get().then
          (querySnapshot => {
              querySnapshot.forEach(doc => {
                  const data = {
                      'id': doc.id,
                      'skill_id': doc.data().skill_id,
                      'name': doc.data().name,
                      'type': doc.data().type
                  }
                  this.mySkills.push(data)
              })
              this.loaded = true
          })
      },

      onDelete(skill_id){
          db.collection('myskills').where('skill_id', '==', skill_id ).get
          ().then(querySnapshot => {
              querySnapshot.forEach(doc => {
                  doc.ref.delete().then(docRef => {
                      this.$router.push('/message')
                  })
              })
          })
      }
    }

}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped lang="scss">

    //@import "https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css";

    .skills {
        width: 100%;

        h2 {
            text-align: center;
        }
        ul {
            width: 80%;
            margin: auto;
            padding: 0;
            list-style-type: none;
            box-shadow: 0px 5px 5px #888888;
        }

        li {
            padding: 20px;
            font-size: 1.3em;
            background-color: #E0EDF4;
            border-left: 5px solid #3EB3F6;
            margin-bottom: 2px;
            color: #3E5252;
            display: flex;
            justify-content: space-between;
        }

        li span {
            width: 15px;
        }

        .newButton {
            width: 50px;
            margin: auto;
            font-size: 2.5rem;
            padding-top: 15px;
            cursor: pointer;

            .plus-circle {
                color: #e12c51;
            }
        }

        .edit-icon {
            color: #3e5252;
        }

    }

    .edit {
        padding-right: 10px;
        cursor: pointer;
    }

    .delete {
        cursor: pointer;
    }

</style>
